searchData={"items":[{"type":"module","title":"Makeup","doc":"Syntax highlighting library for code, inspired by Pygments.\n\nBy default, it doesn't include any lexers. You must import\nthem separately (even the Elixir lexer).","ref":"Makeup.html"},{"type":"function","title":"Makeup.highlight/2","doc":"Highlights the given string using the given lexer and formatter.\n\nBy default it highlight the Elixir language using\n`Makeup.Formatters.HTML.HTMLFormatter`.","ref":"Makeup.html#highlight/2"},{"type":"function","title":"Options: - Makeup.highlight/2","doc":"- `:lexer` - module name of the lexer to use (default: `Makeup.Lexers.ElixirLexer`)\n- `:lexer_options` - list of options for the lexer\n- `:formatter` - module name of the formatter to use (defult: `Makeup.Formatters.HTML.HTMLFormatter`)\n- `:formatter_options` - list of options for the formatter. For the included HTMLFormatter, that's:\n  - `:css_class` - css class(es) of the main ` ` element (default: `\"highlight\"`)\n  - `:highlight_tag` - tag that wraps every token (default: `\"span\"`)","ref":"Makeup.html#highlight/2-options"},{"type":"function","title":"Makeup.highlight_inner_html/2","doc":"Convenience for formatting as the inner bits of HTML.","ref":"Makeup.html#highlight_inner_html/2"},{"type":"function","title":"Makeup.stylesheet/2","doc":"Generates a CSS stylesheet for highlighted code for the given style.\n\nIt expects a `style`, either as an atom name or as \"style map\",\nand the `css_class` as the top level class for highlighted code.\n\nFor example, if the `css_class` is `\"highlight\"` (the default), the stylesheet\nhas the form:\n\n```css\n.highlight .someclass {...}\n.highlight .anotherclass {...}\n```\n\nSee `Makeup.Styles.HTML.StyleMap` for all style maps.","ref":"Makeup.html#stylesheet/2"},{"type":"module","title":"Makeup.Formatters.HTML.HTMLFormatter","doc":"Turns a list of tokens into HTML fragments.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.format_as_binary/2","doc":"Turns a list of tokens into an HTML fragment.\nThis fragment can be embedded directly into an HTML document.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#format_as_binary/2"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.format_as_iolist/2","doc":"Turns a list of tokens into an iolist which represents an HTML fragment.\nThis fragment can be embedded directly into an HTML document.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#format_as_iolist/2"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.format_inner_as_binary/2","doc":"Turns a list of tokens into an HTML fragment.\nThis fragment can be embedded directly into an HTML document.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#format_inner_as_binary/2"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.format_inner_as_iolist/2","doc":"Turns a list of tokens into an iolist which represents an HTML fragment.\nThis fragment can be embedded directly into an HTML document.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#format_inner_as_iolist/2"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.format_token/2","doc":"Format a single token into an iolist.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#format_token/2"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.group_highlighter_javascript/0","doc":"Return a JavaScript snippet to highlight code on mouseover.\nThis is \"raw\" javascript, and for inclusion in an HTML file\nit must be wrapped in a ` ` tag.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#group_highlighter_javascript/0"},{"type":"function","title":"Makeup.Formatters.HTML.HTMLFormatter.stylesheet/2","doc":"Return the CSS stylesheet for a given style.","ref":"Makeup.Formatters.HTML.HTMLFormatter.html#stylesheet/2"},{"type":"behaviour","title":"Makeup.Lexer","doc":"A lexer turns raw source code into a list of tokens.","ref":"Makeup.Lexer.html"},{"type":"callback","title":"Makeup.Lexer.lex/2","doc":"Lexes a string into a list of tokens","ref":"Makeup.Lexer.html#c:lex/2"},{"type":"callback","title":"Makeup.Lexer.match_groups/2","doc":"Matches groups in a list of tokens.","ref":"Makeup.Lexer.html#c:match_groups/2"},{"type":"function","title":"Makeup.Lexer.merge/1","doc":"Merge adjacent tokens of the same type and with the same attributes.\n\nDoing this will require iterating over the list of tokens again,\nso only do this if you have a good reason.","ref":"Makeup.Lexer.html#merge/1"},{"type":"callback","title":"Makeup.Lexer.postprocess/2","doc":"Post-processes a list of tokens before matching the contained groups.","ref":"Makeup.Lexer.html#c:postprocess/2"},{"type":"callback","title":"Makeup.Lexer.root/1","doc":"Parses the given string into a `parsec` result that includes a list of tokens.","ref":"Makeup.Lexer.html#c:root/1"},{"type":"callback","title":"Makeup.Lexer.root_element/1","doc":"Parses the smallest number of tokens that make sense.\nIt's a `parsec`.","ref":"Makeup.Lexer.html#c:root_element/1"},{"type":"function","title":"Makeup.Lexer.split_into_lines/1","doc":"Splits a list of tokens on newline characters (`\n`).\n\nThe result is a list of lists of tokens with no newlines.","ref":"Makeup.Lexer.html#split_into_lines/1"},{"type":"function","title":"Makeup.Lexer.unlex/1","doc":"Merges the token values into the original string.\n\nInverts the output of a lexer. That is, if `lexer` is a lexer, then:\n\n    string |> lexer.lex() |> Makeup.Lexer.unlex() == string\n\nThis only works for a correctly implemented lexer, of course.\nThe above identity can be treated as a lexer invariant for newly implemented lexers.","ref":"Makeup.Lexer.html#unlex/1"},{"type":"module","title":"Makeup.Lexer.Combinators","doc":"Common components useful in many lexers.","ref":"Makeup.Lexer.Combinators.html"},{"type":"function","title":"Makeup.Lexer.Combinators.lexeme/1","doc":"Joins the result of the given combinator into a single string.\n\nThis is not usually necessary, but it can be useful if you want to match on the tokens.\nIt's easier to match on the token `{:keyword, %{}, \"unquote\"}` than on something like\n`{:keyword, %{}, [\"u\", \"nquote\"]}`, even though both tokens will be treated the same way\nby the formatter.","ref":"Makeup.Lexer.Combinators.html#lexeme/1"},{"type":"function","title":"Makeup.Lexer.Combinators.many_surrounded_by/3","doc":"Matches a given combinator, repeated 0 or more times, surrounded by left and right delimiters.\n\nDelimiters can be combinators or literal strings (either both combinators or both literal strings).\n\nIt also succeeds if we get to the end of string and the closing delimiter is missing,\nto avoid parsing the program multiple times in case of mismatched delimeters or invalid programs.","ref":"Makeup.Lexer.Combinators.html#many_surrounded_by/3"},{"type":"function","title":"Makeup.Lexer.Combinators.many_surrounded_by/4","doc":"Matches a given combinator, repeated 0 or more times, surrounded by left and right delimiters,\nand wraps the `right` and `left` delimiters into a token of the given `ttype`.\n\nIt also succeeds if we get to the end of string and the closing delimiter is missing,\nto avoid parsing the program multiple times in case of mismatched delimeters or invalid programs.","ref":"Makeup.Lexer.Combinators.html#many_surrounded_by/4"},{"type":"function","title":"Makeup.Lexer.Combinators.string_like/5","doc":"A generic combinator for string-like syntactic structures.\n\nIt takes the following parameters:\n\n  * `left` - left delimiter for the string. Can be a binary or a general combinator.\n  * `right` - right delimiter for the string. Can be a binary or a general combinator\n  * `middle` - a list of parsers to run inside the string which parse entities\n    that aren't characters.\n    The most common example are special characters and string interpolation\n    for languages that support it like Elixir.\n  * `ttype` - the token type to use for the string delimiters and ordinary characters\n    (tokens parsd by the )\n  * `attrs` - metadata attributes for the string delimiters and ordinary characters","ref":"Makeup.Lexer.Combinators.html#string_like/5"},{"type":"function","title":"Examples - Makeup.Lexer.Combinators.string_like/5","doc":"single_quoted_heredocs = string_like(\n      \"'''\",\n      \"'''\",\n      combinators_inside_string,\n      :string_char\n    )\n\nThe above is equivalent to the following more explicit version:\n\n    single_quoted_heredocs = string_like(\n      string(\"'''\"),\n      string(\"'''\"),\n      combinators_inside_string,\n      :string_char\n    )","ref":"Makeup.Lexer.Combinators.html#string_like/5-examples"},{"type":"function","title":"Makeup.Lexer.Combinators.token/2","doc":"Wraps the given combinator into a token of the given `ttype`.\n\nInstead of a combinator, the first argument can also be a string literal.","ref":"Makeup.Lexer.Combinators.html#token/2"},{"type":"function","title":"Makeup.Lexer.Combinators.token/3","doc":"","ref":"Makeup.Lexer.Combinators.html#token/3"},{"type":"function","title":"Makeup.Lexer.Combinators.word_from_list/1","doc":"Matches one of the literal strings in the list.\n\nThe strings aren't matched in order: they are automatically sorted in a way\nthat guarantees that the longest strings will be tried first.","ref":"Makeup.Lexer.Combinators.html#word_from_list/1"},{"type":"function","title":"Examples - Makeup.Lexer.Combinators.word_from_list/1","doc":"keywords = word_from_list(~w[do end catch after rescue])","ref":"Makeup.Lexer.Combinators.html#word_from_list/1-examples"},{"type":"function","title":"Makeup.Lexer.Combinators.word_from_list/2","doc":"Matches one of the literal strings in the list and wraps it in a token of the given type.\n\nThis is is just a shorthand.\n\nThe strings aren't matched in order: they are automatically sorted in a way\nthat guarantees that the longest strings will be tried first.","ref":"Makeup.Lexer.Combinators.html#word_from_list/2"},{"type":"function","title":"Examples - Makeup.Lexer.Combinators.word_from_list/2","doc":"keywords = word_from_list(~w[do end catch after rescue], :keyword)","ref":"Makeup.Lexer.Combinators.html#word_from_list/2-examples"},{"type":"function","title":"Makeup.Lexer.Combinators.word_from_list/3","doc":"Matches one of the literal strings in the list and wraps it in a token of the given `type`,\nwith the given `attrs`.\n\nThis is is just a shorthand.\n\nThe strings aren't matched in order: they are automatically sorted in a way\nthat guarantees that the longest strings will be tried first.","ref":"Makeup.Lexer.Combinators.html#word_from_list/3"},{"type":"module","title":"Makeup.Lexer.Groups","doc":"Utilities to highlight groups of tokens on mouseover.\n\nThe typical example is to highlight matching pairs of delimiters,\nsuch as parenthesis, angle brackets, etc.","ref":"Makeup.Lexer.Groups.html"},{"type":"macro","title":"Makeup.Lexer.Groups.defgroupmatcher/3","doc":"Defines a function with the given `name` that takes a list of tokens and divides\nmatching delimiters into groups.\n\nTakes as arguments a `name` for the function (must be an atom) and a list\ncontaining the patterns describing the matching groups.","ref":"Makeup.Lexer.Groups.html#defgroupmatcher/3"},{"type":"macro","title":"Examples - Makeup.Lexer.Groups.defgroupmatcher/3","doc":"# Extracted from the default elixir lexer that ships with ExDoc\n    defgroupmatcher :match_groups, [\n      # Match opening and closing parenthesis\n      parentheses: [\n        open: [[{:punctuation, %{language: :elixir}, \"(\"}]],\n        close: [[{:punctuation, %{language: :elixir}, \")\"}]]\n      ],\n\n      # Match more complex delimiters, but still an open and close delimiter\n      fn_end: [\n        open: [[{:keyword, %{language: :elixir}, \"fn\"}]],\n        close: [[{:keyword, %{language: :elixir}, \"end\"}]]\n      ]\n\n      # Match delimiters with middle components\n      do_end: [\n        open: [\n          [{:keyword, %{language: :elixir}, \"do\"}]\n        ],\n        middle: [\n          [{:keyword, %{language: :elixir}, \"else\"}],\n          [{:keyword, %{language: :elixir}, \"catch\"}],\n          [{:keyword, %{language: :elixir}, \"rescue\"}],\n          [{:keyword, %{language: :elixir}, \"after\"}]\n        ],\n        close: [\n          [{:keyword, %{language: :elixir}, \"end\"}]\n        ]\n      ]\n    ]","ref":"Makeup.Lexer.Groups.html#defgroupmatcher/3-examples"},{"type":"function","title":"Makeup.Lexer.Groups.random_prefix/1","doc":"Returns a random prefix for group ids in an HTML file.\n\nThis is useful to avoid collisions.\nThe group ids should be unique for a certain HTML document, and the easiest way of guaranteeing it\nis by generating long random prefixes.","ref":"Makeup.Lexer.Groups.html#random_prefix/1"},{"type":"module","title":"Makeup.Lexer.Postprocess","doc":"Often you'll want to run the token list through a postprocessing stage before\nrunning the formatter.\n\nMost of what we can do in a post-processing stage can be done with more parsing rules,\nbut doing it in a post-processing stage is often easier and faster.\nNever assume one of the options is faster than the other, always measure performance.","ref":"Makeup.Lexer.Postprocess.html"},{"type":"function","title":"Makeup.Lexer.Postprocess.invert_word_map/1","doc":"Takes a list of the format `[{key1, [val11, val12, ...]}, {key2, [val22, ...]}]` and\nreturns a map of the form `%{val11 => key1, val12 => key2, ..., val22 => key2, ...}`.\n\nThe resulting map may be useful to highlight some tokens in a special way\nin a postprocessing step.\n\nYou can also use pattern matching instead of the inverted map,\nand it will probably be faster, but always benchmark the alternatives before\ncommitting to an implementation.","ref":"Makeup.Lexer.Postprocess.html#invert_word_map/1"},{"type":"function","title":"Makeup.Lexer.Postprocess.token_value_to_binary/1","doc":"Converts the value of a token into a binary.\n\nToken values are usually iolists for performance reasons.\nThe BEAM is actually quite fast at printing or concatenating iolists,\nand some of the basic combinators output iolists, so there is no need\nto convert the token values into binaries.\n\nThis function should only be used for tesring purposes, when you might\nwant to compare the token list into a reference output.\n\nConverting the tokens into binaries has two advantges:\n1. It's much easier to compare tokens by visual inspection when the value is a binary\n2. When testing, two iolists that print to the same binary should be considered equal.\n\nThis function hasn't been optimized for speed.\nDon't use in production code.","ref":"Makeup.Lexer.Postprocess.html#token_value_to_binary/1"},{"type":"function","title":"Makeup.Lexer.Postprocess.token_values_to_binaries/1","doc":"Converts the values of the tokens in the list into binaries.\n\nToken values are usually iolists for performance reasons.\nThe BEAM is actually quite fast at printing or concatenating iolists,\nand some of the basic combinators output iolists, so there is no need\nto convert the token values into binaries.\n\nThis function should only be used for tesring purposes, when you might\nwant to compare the token list into a reference output.\n\nConverting the tokens into binaries has two advantges:\n1. It's much easier to compare tokens by visual inspection when the value is a binary\n2. When testing, two iolists that print to the same binary should be considered equal.","ref":"Makeup.Lexer.Postprocess.html#token_values_to_binaries/1"},{"type":"function","title":"Example - Makeup.Lexer.Postprocess.token_values_to_binaries/1","doc":"```elixir\ndefmodule MyTest do\n  use ExUnit.Case\n  alias Makeup.Lexers.ElixirLexer\n  alias Makeup.Lexer.Postprocess\n\n  test \"binaries are much easier on the eyes\" do\n    naive_tokens = ElixirLexer(\":atom\")\n    # Hard to inspect visually\n    assert naive_tokens == [{:string_symbol, %{language: :elixir}, [\":\", \"a\", \"tom\"]}]\n    better_tokens =\n      text\n      |> ElixirLexer.lex()\n      |> Postprocess.token_values_to_binaries()\n    # Easy to inspect visually\n    assert better_tokens == [{:string_symbol, %{language: :elixir}, \":atom\"}]\n  end\nend\n```\n\nActually, you'll want to define some kind of helper to make it less verbose.\nFor example:\n\n    defmodule MyTest do\n      use ExUnit.Case\n      alias Makeup.Lexers.ElixirLexer\n      alias Makeup.Lexer.Postprocess\n\n      def lex(text) do\n        text\n        |> ElixirLexer.lex(group_prefix: \"group\")\n        |> Postprocess.token_values_to_binaries()\n      end\n\n      test \"even better with our little helper\" do\n        assert lex(\":atom\") == [{:string_symbol, %{language: :elixir}, \":atom\"}]\n      end\n    end","ref":"Makeup.Lexer.Postprocess.html#token_values_to_binaries/1-example"},{"type":"module","title":"Makeup.Lexer.Types","doc":"","ref":"Makeup.Lexer.Types.html"},{"type":"type","title":"Makeup.Lexer.Types.context/0","doc":"","ref":"Makeup.Lexer.Types.html#t:context/0"},{"type":"type","title":"Makeup.Lexer.Types.parsec/0","doc":"","ref":"Makeup.Lexer.Types.html#t:parsec/0"},{"type":"type","title":"Makeup.Lexer.Types.parsec_failure/0","doc":"","ref":"Makeup.Lexer.Types.html#t:parsec_failure/0"},{"type":"type","title":"Makeup.Lexer.Types.parsec_result/0","doc":"","ref":"Makeup.Lexer.Types.html#t:parsec_result/0"},{"type":"type","title":"Makeup.Lexer.Types.parsec_success/0","doc":"","ref":"Makeup.Lexer.Types.html#t:parsec_success/0"},{"type":"type","title":"Makeup.Lexer.Types.token/0","doc":"","ref":"Makeup.Lexer.Types.html#t:token/0"},{"type":"type","title":"Makeup.Lexer.Types.tokens/0","doc":"","ref":"Makeup.Lexer.Types.html#t:tokens/0"},{"type":"module","title":"Makeup.Registry","doc":"A registry that allows users to dynamically register new makeup lexers.\n\nLexers should register themselves on application start.\nThat way, you can add support for new programming languages by depending on the relevant lexers.\nThis is useful for projects such as ExDoc, which might contain code\nin a number of different programming languages.","ref":"Makeup.Registry.html"},{"type":"function","title":"Makeup.Registry.fetch_lexer_by_extension/1","doc":"Fetches a lexer from Makeup's registry with the given file `extension`.\n\nReturns either `{:ok, {lexer, options}}` or `:error`.\nThis behaviour is based on `Map.fetch/2`.","ref":"Makeup.Registry.html#fetch_lexer_by_extension/1"},{"type":"function","title":"Makeup.Registry.fetch_lexer_by_extension!/1","doc":"Fetches the lexer from Makeup's registry with the given file `extension`.\n\nReturns either `{:ok, {lexer, options}}` or raises a `KeyError`.\nThis behaviour is based on `Map.fetch/2`.","ref":"Makeup.Registry.html#fetch_lexer_by_extension!/1"},{"type":"function","title":"Makeup.Registry.fetch_lexer_by_name/1","doc":"Fetches the lexer from Makeup's registry with the given `name`.\n\nReturns either `{:ok, {lexer, options}}` or `:error`.\nThis behaviour is based on `Map.fetch/2`.","ref":"Makeup.Registry.html#fetch_lexer_by_name/1"},{"type":"function","title":"Makeup.Registry.fetch_lexer_by_name!/1","doc":"Fetches the lexer from Makeup's registry with the given `name`.\n\nReturns either `{lexer, options}` or raises a `KeyError`.\nThis behaviour is based on `Map.fetch!/2`.","ref":"Makeup.Registry.html#fetch_lexer_by_name!/1"},{"type":"function","title":"Makeup.Registry.get_lexer_by_extension/2","doc":"Gets the lexer from Makeup's registry with the given file `extension`.\n\nReturns either `{lexer, options}` or the `default` value\n(which by default is `nil`).\nThis behaviour is based on `Map.get/3`.","ref":"Makeup.Registry.html#get_lexer_by_extension/2"},{"type":"function","title":"Makeup.Registry.get_lexer_by_name/2","doc":"Gets the lexer from Makeup's registry with the given `name`.\n\nReturns either `{lexer, options}` or the `default` value\n(which by default is `nil`).\nThis behaviour is based on `Map.get/3`.","ref":"Makeup.Registry.html#get_lexer_by_name/2"},{"type":"function","title":"Makeup.Registry.register_lexer/2","doc":"Add a new lexer to Makeup's registry under the given names and extensions.\n\nExpects a lexer `lexer` and a number of options:\n\n  * `:options` (default: `[]`) - the lexer options.\n    If your lexer doesn't take any options, you'll want the default value of `[]`.\n\n  * `:names` (default: `[]`) - a list of strings with the language names for the lexer.\n    Language names are strings, not atoms.\n    Even if there is only one valid name, you must supply a list with that name.\n    To avoid filling the registry unnecessarily, you should normalize your language names\n    to lowercase strings.\n    If the caller wants to support upper case language names for some reason,\n    they can normalize the language names themselves.\n\n  * `:extensions` (default: `[]`) - the list of file extensions for the languages supported by the lexer.\n    For example, the elixir lexer should support the `\"ex\"` and `\"exs\"` file extensions.\n    The extensions should not include the dot.\n    That is, you should register `\"ex\"` and not `\".ex\"`.\n    Even if there is only a supported extension, you must supply a list.","ref":"Makeup.Registry.html#register_lexer/2"},{"type":"function","title":"Example - Makeup.Registry.register_lexer/2","doc":"alias Makeup.Registry\n    alias Makeup.Lexers.ElixirLexer\n    # The `:options` key is not required\n    Registry.register_lexer(ElixirLexer, names: [\"elixir\", \"iex\"], extensions: [\"ex\", \"exs\"])","ref":"Makeup.Registry.html#register_lexer/2-example"},{"type":"function","title":"Makeup.Registry.register_lexer_with_extension/2","doc":"Adds a new lexer to Makeup's registry under the given `extension`.\n\nThis function expects a file extension (e.g. `\"ex\"`) and a pair containing\na `lexer` and a list of `options`.\n\nYou might want to use the `Makeup.Registry.register_lexer/2` function instead.","ref":"Makeup.Registry.html#register_lexer_with_extension/2"},{"type":"function","title":"Examples - Makeup.Registry.register_lexer_with_extension/2","doc":"alias Makeup.Lexers.ElixirLexer\n    alias Makeup.Registry\n\n    Registry.register_lexer_with_extension(\"ex\"), {ElixirLexer, []})\n    Registry.register_lexer_with_extension(\"exs\"), {ElixirLexer, []})","ref":"Makeup.Registry.html#register_lexer_with_extension/2-examples"},{"type":"function","title":"Makeup.Registry.register_lexer_with_name/2","doc":"Adds a new lexer to Makeup's registry under the given `name`.\n\nThis function expects a language name (e.g. `\"elixir\"`) and a pair containing\na `lexer` and a list of `options`.\n\nYou might want to use the `Makeup.Registry.register_lexer/2` function instead.","ref":"Makeup.Registry.html#register_lexer_with_name/2"},{"type":"function","title":"Examples - Makeup.Registry.register_lexer_with_name/2","doc":"alias Makeup.Lexers.ElixirLexer\n    alias Makeup.Registry\n\n    Registry.register_lexer_with_name(\"elixir\", {ElixirLexer, []})\n    Registry.register_lexer_with_name(\"iex\", {ElixirLexer, []})","ref":"Makeup.Registry.html#register_lexer_with_name/2-examples"},{"type":"function","title":"Makeup.Registry.supported_file_extensions/0","doc":"Gets the list of supported language extensions.","ref":"Makeup.Registry.html#supported_file_extensions/0"},{"type":"function","title":"Makeup.Registry.supported_language_names/0","doc":"Gets the list of supported language names.","ref":"Makeup.Registry.html#supported_language_names/0"},{"type":"module","title":"Makeup.Styles.HTML.Style","doc":"The style struct.","ref":"Makeup.Styles.HTML.Style.html"},{"type":"function","title":"Makeup.Styles.HTML.Style.make_style/1","doc":"Creates a new style.\n\nTakes care of unspecified token types and inheritance.\nWrites and caches a CSS stylesheet for the style.","ref":"Makeup.Styles.HTML.Style.html#make_style/1"},{"type":"function","title":"Makeup.Styles.HTML.Style.stylesheet/2","doc":"Generate a stylesheet for a style.","ref":"Makeup.Styles.HTML.Style.html#stylesheet/2"},{"type":"module","title":"Makeup.Styles.HTML.StyleMap","doc":"This module contains all styles, and facilities to map style names (binaries or atoms) to styles.\n\nStyle names are of the form ` _style`.","ref":"Makeup.Styles.HTML.StyleMap.html"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.abap_style/0","doc":"The *abap* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#abap).","ref":"Makeup.Styles.HTML.StyleMap.html#abap_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.algol_nu_style/0","doc":"The *algol_nu* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#algol_nu).","ref":"Makeup.Styles.HTML.StyleMap.html#algol_nu_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.algol_style/0","doc":"The *algol* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#algol).","ref":"Makeup.Styles.HTML.StyleMap.html#algol_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.arduino_style/0","doc":"The *arduino* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#arduino).","ref":"Makeup.Styles.HTML.StyleMap.html#arduino_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.autumn_style/0","doc":"The *autumn* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#autumn).","ref":"Makeup.Styles.HTML.StyleMap.html#autumn_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.borland_style/0","doc":"The *borland* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#borland).","ref":"Makeup.Styles.HTML.StyleMap.html#borland_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.bw_style/0","doc":"The *bw* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#bw).","ref":"Makeup.Styles.HTML.StyleMap.html#bw_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.colorful_style/0","doc":"The *colorful* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#colorful).","ref":"Makeup.Styles.HTML.StyleMap.html#colorful_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.default_style/0","doc":"The *default* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#default).","ref":"Makeup.Styles.HTML.StyleMap.html#default_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.dracula_style/0","doc":"The *dracula* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#dracula).","ref":"Makeup.Styles.HTML.StyleMap.html#dracula_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.emacs_style/0","doc":"The *emacs* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#emacs).","ref":"Makeup.Styles.HTML.StyleMap.html#emacs_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.friendly_style/0","doc":"The *friendly* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#friendly).","ref":"Makeup.Styles.HTML.StyleMap.html#friendly_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.fruity_style/0","doc":"The *fruity* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#fruity).","ref":"Makeup.Styles.HTML.StyleMap.html#fruity_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.igor_style/0","doc":"The *igor* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#igor).","ref":"Makeup.Styles.HTML.StyleMap.html#igor_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.lovelace_style/0","doc":"The *lovelace* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#lovelace).","ref":"Makeup.Styles.HTML.StyleMap.html#lovelace_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.manni_style/0","doc":"The *manni* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#manni).","ref":"Makeup.Styles.HTML.StyleMap.html#manni_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.monokai_style/0","doc":"The *monokai* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#monokai).","ref":"Makeup.Styles.HTML.StyleMap.html#monokai_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.murphy_style/0","doc":"The *murphy* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#murphy).","ref":"Makeup.Styles.HTML.StyleMap.html#murphy_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.native_style/0","doc":"The *native* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#native).","ref":"Makeup.Styles.HTML.StyleMap.html#native_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.one_dark_style/0","doc":"The *one_dark* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#one_dark).","ref":"Makeup.Styles.HTML.StyleMap.html#one_dark_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.paraiso_dark_style/0","doc":"The *paraiso_dark* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#paraiso_dark).","ref":"Makeup.Styles.HTML.StyleMap.html#paraiso_dark_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.paraiso_light_style/0","doc":"The *paraiso_light* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#paraiso_light).","ref":"Makeup.Styles.HTML.StyleMap.html#paraiso_light_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.pastie_style/0","doc":"The *pastie* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#pastie).","ref":"Makeup.Styles.HTML.StyleMap.html#pastie_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.perldoc_style/0","doc":"The *perldoc* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#perldoc).","ref":"Makeup.Styles.HTML.StyleMap.html#perldoc_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.rainbow_dash_style/0","doc":"The *rainbow_dash* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#rainbow_dash).","ref":"Makeup.Styles.HTML.StyleMap.html#rainbow_dash_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.rrt_style/0","doc":"The *rrt* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#rrt).","ref":"Makeup.Styles.HTML.StyleMap.html#rrt_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.samba_style/0","doc":"The *samba* style, based on the tango style, but with visual distinction between\nclasses and variables, and lighter punctuation.","ref":"Makeup.Styles.HTML.StyleMap.html#samba_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.tango_style/0","doc":"The *tango* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#tango).","ref":"Makeup.Styles.HTML.StyleMap.html#tango_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.trac_style/0","doc":"The *trac* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#trac).","ref":"Makeup.Styles.HTML.StyleMap.html#trac_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.vim_style/0","doc":"The *vim* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#vim).","ref":"Makeup.Styles.HTML.StyleMap.html#vim_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.vs_style/0","doc":"The *vs* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#vs).","ref":"Makeup.Styles.HTML.StyleMap.html#vs_style/0"},{"type":"function","title":"Makeup.Styles.HTML.StyleMap.xcode_style/0","doc":"The *xcode* style. Example [here](https://elixir-makeup.github.io/makeup_demo/elixir.html#xcode).","ref":"Makeup.Styles.HTML.StyleMap.html#xcode_style/0"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"1.1.2 - 2024-05-11 - Changelog","doc":"Do not attempt reparsing if surrounded by reaches end of string.","ref":"changelog.html#1-1-2-2024-05-11"},{"type":"extras","title":"1.1.1 - 2023-11-08 - Changelog","doc":"Add dracula theme.\n\nAdd one dark theme.\n\nFix warnings on recent Elixir versions.","ref":"changelog.html#1-1-1-2023-11-08"},{"type":"extras","title":"1.1.0 - 2022-02-12 - Changelog","doc":"Require NimbleParsec `~> 1.2.2` onwards to prepare for future deprecations.","ref":"changelog.html#1-1-0-2022-02-12"},{"type":"extras","title":"1.0.5 - 2020-10-02 - Changelog","doc":"#### Bugfix #1\n\nFix serious bug in the `Makeup.Lexer.Combinators.lexeme/1` when given a list of unicode characters.\n\nBefore this fix, the following combinator:\n\n```\nimport Makeup.Lexer.Combinators\n\ncharacters_lexeme =\n  utf8_char([])\n  |> utf8_char([])\n  |> lexeme()\n  |> token(:character_lexeme)\n```\n\nwhen given as input a string like `\"àó\"` would return the following invalid Unicode:\n\n```\n[{:character_lexeme, %{}, <<225, 242>>}]\n```\n\ninstead of\n\n```\n[{:character_lexeme, %{}, \"áò\"}]\n```\n\nThis was caused by the use of `IO.iodata_to_binary/1` instead of (the slower) `to_string()`. This was a problem because `IO.iodata_to_binary/1` would put any byte in a binary instead of (correctly) encoding bytes > 128 as a Unicode character. This is not a problem with `IO.iodata_to_binary/1` it's a problem with using that function when we want to encode characters as Unicode strings.\n\n#### Bugfix #2\n\nFixed an edge case in the HTML encoder in the formatter.","ref":"changelog.html#1-0-5-2020-10-02"},{"type":"extras","title":"1.0.4 - 2020-09-25 - Changelog","doc":"Fix warnings and update NimbleParsec dependency.","ref":"changelog.html#1-0-4-2020-09-25"},{"type":"extras","title":"1.0.3 - 2020-06-07 - Changelog","doc":"Allow styles to be given as atoms when generating stylesheets.","ref":"changelog.html#1-0-3-2020-06-07"},{"type":"extras","title":"1.0.2 - 2020-05-28 - Changelog","doc":"Update NimbleParsec dependency.","ref":"changelog.html#1-0-2-2020-05-28"},{"type":"extras","title":"1.0.1 - 2020-03-24 - Changelog","doc":"Remove warnings on recent Elixir versions.","ref":"changelog.html#1-0-1-2020-03-24"},{"type":"extras","title":"1.0.0 - 2019-07-15 - Changelog","doc":"Upgrade the HTML formatter so that you can use different kinds of tags around the tokens.\n\nPrevious versions always used the ` ` tag (e.g. ` name `).\nYou can now use other HTML tags using the `:highlight_tag` option:\n\n```elixir\nalias Makeup.Formatters.HTML.HTMLFormatter\nHTMLFormatter.format_as_iolist(tokens, highlight_tag: \"font\")\n```","ref":"changelog.html#1-0-0-2019-07-15"},{"type":"extras","title":"0.8.0 - 2019-01-01 - Changelog","doc":"This release adds a new file extension registry for lexers.\nThis means that it's now possible to lookup lexers by file extension.\nSince the previous release it was already possible to lookup lexers by language name.\nFor example:\n\n```elixir\nelixir_lexer = Makeup.Registry.fetch_lexer_by_extension!(\"elixir\")\n```\n\nNow you can also do this this:\n\n```elixir\nelixir_lexer = Makeup.Registry.get_lexer_by_extension!(\"ex\")\n```\n\nDocumentation of the registry functionality was also improved.","ref":"changelog.html#0-8-0-2019-01-01"},{"type":"extras","title":"0.7.0 - 2018-12-30 - Changelog","doc":"Adds a register where lexer developers can register their lexers.\nThis allows one to pick a lexer based on the language name.\n\nThe goal is for Makeup to be aware of the available lexers.\nIn a project such as ExDoc this allows Makeup to support an unbounded number of languages just by declaring the lexer as a dependency.","ref":"changelog.html#0-7-0-2018-12-30"},{"type":"extras","title":"0.6.0 - 2018-12-22 - Changelog","doc":"Fixes the combinators affected by compatibility breaks in `nimble_parsec` from `0.4.x` to `0.5.x`.\n\nPins `nimble_parsec` to version `0.5.0`.","ref":"changelog.html#0-6-0-2018-12-22"},{"type":"extras","title":"Contributing","doc":"# Contributing\n\nThis document is meant to help people who want to contribute to Makeup.","ref":"contributing.html"},{"type":"extras","title":"The release script - Contributing","doc":"This project uses a release script to make it easy to publish a new release.\nThe script performs a series of checks and executes a number of tasks.\n\nThe script was inspired by the continuous release philosophy of the Python Hypothesis library.\nYou can find a high-level description [here](https://hypothesis.works/articles/continuous-releases/).\nThere are many differences though.\nThe main one is that this release script acts purely locally, and must be explicitly invoked,\nwhile the one in hypothesis is a commit hook that runs on a continuous integration server.\n\nCurrently, the script does the following:\n\n  1. Run the tests (abort the release if any tests fail)\n  2. Get the current version from the `mix.exs` file\n  3. Read a special `RELEASE.md` file to extract the release type (major, minor or patch)\n     and the text to add as a new entry in the CHANGELOG\n  4. Update the version\n  5. Add the new version to the `mix.exs` file\n  6. Add a new entry to the CHANGELOG\n  7. Commit the changes to Git\n  8. Add a `vX.Y.Z` tag to the repo, so that it's easy to find each release\n  9. Remove the `RELEASE.md` file, which must be written again for a new release\n  10. Publish the package on Hex.pm\n\nIt decreases the number of mistakes and the amount of commands you need to run.\n\nThe path to the script is `scripts/release.exs`.\nThe `mix.exs` file defines an alias so that you can run the script `mix release`.","ref":"contributing.html#the-release-script"},{"type":"extras","title":"Special files - Contributing","doc":"","ref":"contributing.html#special-files"},{"type":"extras","title":"The `RELEASE.md` file - Contributing","doc":"The `RELEASE.md` file must start with a line of the form `RELEASE_TYPE: type`,\nwhere type is either `major`, `minor` or `patch`.\n\nThe following lines are used as the text for the entry in the changelog file.\n\nA simple example of a `RELEASE.md` file would be:\n\n    RELEASE_TYPE: minor\n\n    This is a minor release.\n    It adds a minor feature and fixes two important bugs.","ref":"contributing.html#the-release-md-file"},{"type":"extras","title":"The `CHANGELOG.md` file - Contributing","doc":"The `CHANGELOG.md` file must contain the following line:\n\n    <!-- %% CHANGELOG_ENTRIES %% -->\n\nThe newest changelog entry will be under this line.","ref":"contributing.html#the-changelog-md-file"},{"type":"extras","title":"Using - Contributing","doc":"# High Level Architecture","ref":"contributing.html#using"},{"type":"extras","title":"What Makeup Is - Contributing","doc":"The goal of Makeup is to take up something plain, and turn it into something pretty.\nThe previous sentence is only the first of probably many puns about makeup.\n\nMakeup takes as argument a string representing source code,\nand returns some data that contains the highlighted source code.\n\nCurrently, Makeup only supports HTML output (actually HTML + CSS + a little JavaScript).\nIn the future it might support other kinds of output.\n\nIt's made up of three parts:\n\n  * The *Lexer*, which turns the raw source code into a list of tokens.\n    There must be a lexer per programming language.\n  * The *Formatter*, which turns the list of tokens into something else\n    (what exactly is format dependent).\n  * The *Styles*, which control the output of the Formatter.\n\nThe main goal of having syntax highlighting is to make the code more understandable\nfor a *human* audience.\nAs discussed above, there is no need to actually parse the raw source into a valid AST.\nThis allows us to make lots of simplifications regarding what exactly to parse,\nand which kinds of tokens we recognize.","ref":"contributing.html#what-makeup-is"},{"type":"extras","title":"What Makeup Is Not - Contributing","doc":"Makeup is not a static code analyzer.\nAs an analyzer, Makeup is very shallow and only cares about the surface details of your code.\nThe goal here is to make the code pretty to humans, not to gain any deep insights.\n\nMakeup is not a general-purpose language parser.\nIf it helps you write a better lexer, by all means implement a parser\nfor the language in question so that you can lex it better,\nbut in general it's probably not worth it.\n\nMakeup is not a tool to hyperlink your source code.\nWhile such tools might be built on top of Makeup, it's not the original goal.\n\n# Lexers\n\nThe *Lexer*, turns the raw source code into a flat list of tokens.","ref":"contributing.html#what-makeup-is-not"},{"type":"extras","title":"Tokens - Contributing","doc":"A token has the following type:\n\n```elixir\n{atom(), map(), String.t()}\n```\n\nThe token format was inspired by the format of an Elixir AST node.\n\n  * The *first* element of the 3-tuple is the type of token.\n    Makeup supports a limited number of token types.\n    The supported token types are: [[...]](#supported-tokens)\n\n  * The *second* element is a map, containing some metadata about the token.\n    Some formatters can make use of the metadata in order to improve the output.\n    The only metadata keys currently used by the HTML formatter are the `:group_id` and the `:unselectable` keys.\n\n    * `:group_id` is used to mark delimiters as belonging to the same group, so that they are both highlighted when the user places the mouse cursor on top of one of them.\n\n    * `:unselectable` is used to mark a certain token as impossible to select in the HTML output.\n      It's useful for prompts in interactive interpreter sessions, which you usually don't want to copy and paste.\n\n  * The *third* element is an iolist (not exactly, see below) or a binary containing the text that forms the token.\n    Makeup lexers should by default use iolists instead of binaries because they usually bring better performance.\n\nFor example, the following are valid tokens:\n\n  * `{:name, %{}, \"a\"}` - represents the variable `a`\n\n  * `{:string_double, %{}, \"\\\"A String\\\"\"}` - represents a literal string\n\n  * `{:number_integer, %{}, [\"17\"]}` - represents the number `17`","ref":"contributing.html#tokens"},{"type":"extras","title":"Note: iolists and makeup - Contributing","doc":"The above description of the third element of the token is a slight simplification.\nErlang iolists can contain *binaries*, *lists* and *integers representing bytes*.\nThey can't contain arbitrary integers that encode Unicode characters.\n\nIt's very inconvenient to handle these Unicode characters inside the lexer,\nso Makeup has chosen to handle them inside the *formatter*, which actually writes the \"iolists\" into an output device or a string.\n\nBecause the *formatter* usually has to escape the token values anyway, it is natural to \"escape\" Unicode characters at that level.","ref":"contributing.html#note-iolists-and-makeup"},{"type":"extras","title":"Improving an Existing Lexer - Contributing","doc":"There are probably lots of opportunities to profile the lexers and increase performance.\nAlthough performance is important, being correct is also important.\nWhen faced with the choice between being fast or being correct, you should be aware of the trade-off.","ref":"contributing.html#improving-an-existing-lexer"},{"type":"extras","title":"Writing a New Lexer - Contributing","doc":"Makeup lexers use the excellent [NimbleParsec](https://github.com/plataformatec/nimble_parsec) parsing library by default.\nWriting a NimbleParsec parser is not a requirement to write an Elixir lexer.\nAs said above, a lexer is just a module that implements the behavior above.\n\nYou can write your lexer in any way you want.\nYou may use a different parsing library, a custom tokenizer, or even something like Regex.\nOn the other hand, by doing so you won't be making use of the combinators defined by Makeup.\n\nBecause a Lexer is just a module that implements a behavior,\nthere is no need for your grammar rules to output the final token stream.\nYou can process the token stream any way you want, as long as the format is the same.\nFor example, the current Elixir lexer iterates over the identifiers\nin the token list to highlight some keywords such as `if`, `when` and `defmodule`.\n\nMakeup now provides an API to register lexers on application start.\nThis means that you can dynamically add support for new programming languages by just depending on a new lexer (as long as the application which is using Makeup knows how to get a lexer from the registry, of course).\n\nThe lexer has the responsibility to register itself on application start.","ref":"contributing.html#writing-a-new-lexer"},{"type":"extras","title":"Matching delimiters - Contributing","doc":"A new lexer should make an effort to match delimiters such as parenthesis when appropriate.\nSuch matched delimiters can be highlighted when the user places the mouse cursor\non top of one of the delimiters.\nThis makes it easy to visualize which part of the code is surrounded by the delimiters.\nThis is not a hard requirement for a new lexer, of course, but it's probably\nquite easy to implement for almost every language.\n\n```html\n  \n def  f ( x ) \n  do  \n  x + 1\n  end  \n  \n```","ref":"contributing.html#matching-delimiters"},{"type":"extras","title":"Aside: A Parser? Why not Regexes? They're simpler... - Contributing","doc":"Can't I just use a Regex-based lexer like normal people?\n\nWell, you can if you really want to.\nBut Regexes are very weak, and clearly not enough to lex most programming languages.\n\nMost Regex-based lexers (like those employed by Pygments) are actually state machines\nwith arbitrarily deep stacks with state transitions driven by Regex matches.\nThis is equivalent to a stack-based automaton, which allows these lexers\nto support arbitrary levels of nesting.\n\nThis is good enough to reasonably tokenize most programming languages,\nbut it's much more low level than NimbleParsec (and probably slower).\nNimbleParsec allows you to define possibly recursive rules\nand handles the state transitions itself, probably with better performance.\n\nIt's quite easy to port a Pygments lexer into Elixir, and sometimes they are shorter.\nThe hardest part is actually extracting the rules from the Regex-driven state machine.\n\n# Formatter\n\nA formatter is an arbitrary module, which exports functions that perform arbitrary transformations on your list of tokens.\nThe output formats are so different that it doesn't really make much sense for a formatter to implement a behavior.\nSome formatters should only output iolists, while others should only output binaries.\nOthers might not produce any output.\nThink for example of a code formatter for a GUI application, which may work only by running function calls that statefully change the UI state.\n\nUsually you'll want to implement two functions:\n\n  * `format_as_iolist(tokens, opts \\\\ [])` (converts a list of tokens into an iolist)\n  * `format_as_binary(tokens, opts \\\\ [])` (converts a list of tokens into a binary)","ref":"contributing.html#aside-a-parser-why-not-regexes-they-re-simpler"},{"type":"extras","title":"Note: why iolists? - Contributing","doc":"Concatenating strings is very slow on the BEAM.\nThe fast way to generate strings is to first generate an iolist and then calling `IO.iodata_to_binary/1` on the iolist to generate a binary.","ref":"contributing.html#note-why-iolists"},{"type":"extras","title":"Improving an Existing Formatter - Contributing","doc":"The HTML formatter probably doesn't need many improvements.","ref":"contributing.html#improving-an-existing-formatter"},{"type":"extras","title":"Writing a New Formatter - Contributing","doc":"Some formatters that would be interesting to have:\n\n  * HTML Formatter with inline CSS styles (the default one uses CSS classes)\n  * (La)TeX Formatter\n  * Formatter suitable for use in terminals\n\nWhile lexers will remain in separate packages for the foreseeable future,\nI think formatters could be available on Makeup itself.\nYou can of course write your own formatters tailored to your projects.\n\nBe sure to use iolists instead of binaries whenever possible.\n\n# Style","ref":"contributing.html#writing-a-new-formatter"},{"type":"extras","title":"Improving an Existing Style - Contributing","doc":"While existing styles could use some improvements, you're probably better off\nwriting and contributing new ones.","ref":"contributing.html#improving-an-existing-style"},{"type":"extras","title":"Writing a New Style - Contributing","doc":"Writing a style is easy.\nA style is just an Elixir module that can be converted into a CSS stylesheet.\nIf you prefer, you can write the CSS stylesheet directly for your application,\nbut for now, Makeup will only accept styles written as Elixir modules.\n\nIt's possible that in the future there will be a macro that generates an\nElixir module at compile-time from a CSS stylesheet.\nIt's probably not too hard to write a simple CSS parser and interpreter using NimbleParsec.\n\n# Writing Documentation","ref":"contributing.html#writing-a-new-style"},{"type":"extras","title":"Improving Makeup's Documentation - Contributing","doc":"This document is a work in progress.\nEducating people so that they can contribute (especially new lexers) is a priority.\nA tool such as Makeup depends on the work of many people, as no one is proficient\nin all the programming languages Makeup might have to highlight.\n\nAlso, at the moment, the options recognized by the lexers are not documented properly.","ref":"contributing.html#improving-makeup-s-documentation"},{"type":"extras","title":"Improving NimbleParsec's Documentation - Contributing","doc":"Makeup lexers depend on NimbleParsec.\nThe NimbleParsec docs and test suite are somewhat lacking at the moment.\nTeaching people how to use NimbleParsec is important if we want to encourage new contributions.\nCurrently, not many people are using NimbleParsec, so building a knowledge base around it might be important.\n\n# Adoption and Marketing\n\nIncreasing the adoption of Makeup is desirable, because not only it enhances\nthe readability of code examples in the wild, but it might bring new contributors.\nNew contributors bring new lexers, which bring higher adoption, which brings new contributors.\nThis is a virtuous cycle we must encourage.\n\n---\n#### Supported Tokens   \n\n```elixir\n    :comment\n    :comment_hashbang\n    :comment_multiline\n    :comment_preproc\n    :comment_preproc_file\n    :comment_single\n    :comment_special\n    :error\n    :escape\n    :generic\n    :generic_deleted\n    :generic_emph,\n    :generic_error\n    :generic_heading,\n    :generic_inserted\n    :generic_output,\n    :generic_prompt\n    :generic_strong\n    :generic_subheading\n    :generic_traceback\n    :keyword\n    :keyword_constant\n    :keyword_declaration,\n    :keyword_namespace\n    :keyword_pseudo\n    :keyword_reserved\n    :keyword_type,\n    :literal\n    :literal_date\n    :name\n    :name_attribute\n    :name_builtin,\n    :name_builtin_pseudo\n    :name_class\n    :name_constant\n    :name_decorator\n    :name_entity\n    :name_exception\n    :name_function\n    :name_function_magic\n    :name_label\n    :name_namespace\n    :name_other\n    :name_property\n    :name_tag\n    :name_variable,\n    :name_variable_class,\n    :name_variable_global\n    :name_variable_instance\n    :name_variable_magic\n    :number,\n    :number_bin\n    :number_float,\n    :number_hex\n    :number_integer\n    :number_integer_long\n    :number_oct,\n    :operator,\n    :operator_word,\n    :other\n    :punctuation\n    :string\n    :string_affix\n    :string_backtick,\n    :string_char\n    :string_delimiter,\n    :string_doc\n    :string_double\n    :string_escape\n    :string_heredoc\n    :string_interpol,\n    :string_other\n    :string_regex\n    :string_sigil\n    :string_single\n    :string_symbol\n    :text\n    :whitespace\n```","ref":"contributing.html#improving-nimbleparsec-s-documentation"},{"type":"extras","title":"Makeup","doc":"# Makeup\n\n[![Module Version](https://img.shields.io/hexpm/v/makeup.svg)](https://hex.pm/packages/makeup)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/makeup/)","ref":"readme.html"},{"type":"extras","title":"Introduction - Makeup","doc":"Makeup is a \"generic syntax highlighter suitable for use in code hosting, forums, wikis or other applications that need to prettify source code\" . This tagline was shamelessly stolen from the [Pygments website](http://pygments.org/).\n\nPygments the major inspiration for this package, and the structure is basically the same.\nIt has **lexers**, **formatters** and **styles**.\n\n* **Lexers** turn the source code into a list of tokens.\n* **Formatters** turn the list of tokens into something else (HTML, TeX, images, etc.).\n  Currently only an HTML formatter exists.\n* **Styles** customize the output of the formatter.\n  Makeup supports all Pygments' styles (in fact, they were converted from the Python's source).\n  New custom styles can be added to makeup itself, or defined in the Project that uses it.","ref":"readme.html#introduction"},{"type":"extras","title":"Demo - Makeup","doc":"To see a sample of Makeup's output, go check the [demo](https://elixir-makeup.github.io/makeup_demo/).\nPlease note that not all styles define all differences between tokens.\nIn a given style, strings and characters might be rendered in the same color while in others , the colors might be different.\n\nThat is style-dependent.\n\nSome of the richer styles are\nthe Tango style ([elixir](https://elixir-makeup.github.io/makeup_demo/elixir.html#tango)),\nthe Colorful style ([elixir](https://elixir-makeup.github.io/makeup_demo/elixir.html#colorful)),\nthe Default style ([elixir](https://elixir-makeup.github.io/makeup_demo/elixir.html#default)), and\nthe Friendly style ([elixir](https://elixir-makeup.github.io/makeup_demo/elixir.html#friendly)).","ref":"readme.html#demo"},{"type":"extras","title":"Supported Languages - Makeup","doc":"The supported source languages are:\n\n  * [Elixir](https://github.com/elixir-makeup/makeup_elixir)\n  * [Erlang](https://github.com/elixir-makeup/makeup_erlang)\n  * [C](https://github.com/elixir-makeup/makeup_c)\n  * [HTML](https://github.com/elixir-makeup/makeup_html)\n  * [Diff](https://github.com/elixir-makeup/makeup_diff)\n  * [JSON](https://github.com/elixir-makeup/makeup_json)\n  * [(H)EEx](https://github.com/elixir-makeup/makeup_eex)","ref":"readme.html#supported-languages"},{"type":"extras","title":"Installation - Makeup","doc":"The package can be installed by adding `makeup` and `makeup_elixir` (required\nfor the ElixirLexer) to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:makeup, \"x.y.z\"},\n    {:makeup_elixir, \"x.y.z\"}\n  ]\nend\n```\n\nDocumentation can be found at [https://hexdocs.pm/makeup](https://hexdocs.pm/makeup).","ref":"readme.html#installation"},{"type":"extras","title":"Changes - Makeup","doc":"Changes from previous versions are details in the [Changelog](CHANGELOG.md).","ref":"readme.html#changes"},{"type":"extras","title":"Quickstart - Makeup","doc":"To highlight some Elixir code (newlines added for clarity):\n\n```elixir\nMakeup.highlight(source)\n# \"  \n#    x    \n#    +     1 \n#   \\n\"\n```\n\nAs you can see, the default HTML formatter uses CSS classes.\nYou'll need a CSS stylesheet to get the different colors and styles.\n\nTo generate a stylesheet:\n\n```\nMakeup.stylesheet(style) # by default, the StyleMap.default style is used.\n# ... output omitted\n```","ref":"readme.html#quickstart"},{"type":"extras","title":"Advantages over Pygments - Makeup","doc":"One of the greatest advantages is that it runs on the BEAM, so it can be used with Elixir projects without external dependencies.\n\nAnother advantage is that the way lexers are written, we can be a lot smarter than Pygments in processing the output.\n\nFor the developer, lexers are also easier to write than the Pygments lexers, because we use a PEG parser.\nMost Pygments lexers use something like a state table that works based on regex matches,\nand uses the results of those matches to switch to another state.\nUsing a PEG parser we can define the grammar in a more natural way.\n\n\nThe lexers are written using the excellent [NimbleParsec](https://github.com/dashbitco/nimble_parsec) parser.","ref":"readme.html#advantages-over-pygments"},{"type":"extras","title":"Disadvantages over Pygments - Makeup","doc":"It supports fewer languages.","ref":"readme.html#disadvantages-over-pygments"},{"type":"extras","title":"Documentation on how to write a new lexer - Makeup","doc":"Contributions are highly appreciated. The most direct way you can contribute to Makeup is by writing a new lexer. You can find some information here: [CONTRIBUTING.md](CONTRIBUTING.md)","ref":"readme.html#documentation-on-how-to-write-a-new-lexer"},{"type":"extras","title":"LICENSE - Makeup","doc":"Makeup is licensed under the BSD license.\nThis is the same license as the Pygments Makeup uses and\nit seems to be compatible with the licenses used by all the dependencies.","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,50]}}